/********************************************************************\

  Name:         rpc_clnt.c
  Created by:   Stefan Ritt

  Contents:     Mini RPC client program for test purposes.


  Revision history
  ------------------------------------------------------------------
  date        by    modification
  ---------   ---   ------------------------------------------------
  13-JUN-94   SR    created


\********************************************************************/

#include "midas.h"
#include <stdio.h>

#define RPC_TEST RPC_MIN_ID

RPC_LIST rpc_list[] = {

  { RPC_TEST,
    {{TID_BYTE,       RPC_IN}, 
     {TID_WORD,       RPC_IN}, 
     {TID_INT,        RPC_IN}, 
     {TID_FLOAT,      RPC_IN}, 
     {TID_DOUBLE,     RPC_IN}, 
     {TID_BYTE,       RPC_OUT}, 
     {TID_WORD,       RPC_OUT}, 
     {TID_INT,        RPC_OUT}, 
     {TID_FLOAT,      RPC_OUT}, 
     {TID_DOUBLE,     RPC_OUT}, 
     {0} }},

  { 0 }

};

/*------------------------------------------------------------------*/

main()
{
char   host_name[30];
HNDLE  hConn;
INT    status;
BYTE   b;
WORD   w;
INT    i;
float  f;
double d;

  printf("Remote host IP address: ");
  gets(host_name);
  if (host_name[0] == 0)
    {
    printf("A valid host name must be supplied.\n");
    return 0;
    }

  rpc_set_name("RPC_CLNT");
  rpc_register_functions(rpc_list, NULL);

  status = rpc_connect(host_name, 1750, "", &hConn);
  if (status != RPC_SUCCESS)
    {
    printf("Cannot connect to RPC server running on %s at port 1750.\n", host_name);
    return 0;
    }

  f = 3.5f;
  d = 4.5;

  /* rpc_test just doubles numbers */
  rpc_call(hConn, RPC_TEST, 1, 2, 3l, f, d, &b, &w, &i, &f, &d);

  printf("\nResult should be:  2 4 6 7.0 9.0\n");
  printf("Result is:         %d %d %ld %1.1f %1.1lf\n", b, w, i, f, d);

  printf("\nhit return...");
  b = getchar();

  rpc_disconnect(hConn, FALSE);
  return 1;
}
